Index: include/bn.h
===================================================================
--- include/bn.h	(revision 49726)
+++ include/bn.h	(working copy)
@@ -1015,28 +2561,114 @@
     size_t dgr;
     double cf[BN_MAX_POLY_DEGREE+1];
 }  bn_poly_t;
+
 #define BN_CK_POLY(_p) BU_CKMAG(_p, BN_POLY_MAGIC, "struct bn_poly")
 #define BN_POLY_NULL   ((struct bn_poly *)NULL)
 
+
+
+/**
+ * bn_poly_mul
+ *
+ * @brief 
+ * multiply two polynomials
+ */
 BN_EXPORT extern struct bn_poly *bn_poly_mul(struct bn_poly *product,
 					     const struct bn_poly *m1,
 					     const struct bn_poly *m2);
+					     
+/**
+ * bn_poly_scale
+ * 
+ * @brief
+ * scale a polynomial
+ */
 BN_EXPORT extern struct bn_poly *bn_poly_scale(struct bn_poly *eqn,
 					       double factor);
+					       
+/**
+ * bn_poly_add
+ * @brief
+ * add two polynomials
+ */
 BN_EXPORT extern struct bn_poly *bn_poly_add(struct bn_poly *sum,
 					     const struct bn_poly *poly1,
 					     const struct bn_poly *poly2);
+					     
+/**
+ * bn_poly_sub
+ * @brief
+ * subtract two polynomials
+ */
 BN_EXPORT extern struct bn_poly *bn_poly_sub(struct bn_poly *diff,
 					     const struct bn_poly *poly1,
 					     const struct bn_poly *poly2);
+					     
+/**
+ * s y n D i v
+ * @brief
+ * Divides any polynomial into any other polynomial using synthetic
+ * division.  Both polynomials must have real coefficients.
+ */
 BN_EXPORT extern void bn_poly_synthetic_division(struct bn_poly *quo,
 						 struct bn_poly *rem,
 						 const struct bn_poly *dvdend,
 						 const struct bn_poly *dvsor);
+						 
+/**
+ * b n _ p o l y _ q u a d r a t i c _ r o o t s
+ *@brief
+ * Uses the quadratic formula to find the roots (in `complex' form) of
+ * any quadratic equation with real coefficients.
+ *
+ *	@return 1 for success
+ *	@return 0 for fail.
+ */
 BN_EXPORT extern int bn_poly_quadratic_roots(struct bn_complex roots[],
 					     const struct bn_poly *quadrat);
+					     
+/**
+ * b n _ p o l y _ c u b i c _ r o o t s
+ *@brief
+ * Uses the cubic formula to find the roots (in `complex' form)
+ * of any cubic equation with real coefficients.
+ *
+ * to solve a polynomial of the form:
+ *
+ * X**3 + c1*X**2 + c2*X + c3 = 0,
+ *
+ * first reduce it to the form:
+ *
+ * Y**3 + a*Y + b = 0,
+ *
+ * where
+ * Y = X + c1/3,
+ * and
+ * a = c2 - c1**2/3,
+ * b = (2*c1**3 - 9*c1*c2 + 27*c3)/27.
+ *
+ * Then we define the value delta,   D = b**2/4 + a**3/27.
+ *
+ * If D > 0, there will be one real root and two conjugate
+ * complex roots.
+ * If D = 0, there will be three real roots at least two of
+ * which are equal.
+ * If D < 0, there will be three unequal real roots.
+ *
+ * Returns 1 for success, 0 for fail.
+ */
 BN_EXPORT extern int bn_poly_cubic_roots(struct bn_complex roots[],
 					 const struct bn_poly *eqn);
+					 
+/**
+ * b n _ p o l y _ q u a r t i c _ r o o t s
+ *@brief
+ * Uses the quartic formula to find the roots (in `complex' form)
+ * of any quartic equation with real coefficients.
+ *
+ *	@return 1 for success
+ *	@return 0 for fail.
+ */
 BN_EXPORT extern int bn_poly_quartic_roots(struct bn_complex roots[],
 					   const struct bn_poly *eqn);
 BN_EXPORT extern int bn_poly_findroot(bn_poly_t *eqn, 
@@ -1047,26 +2679,51 @@
 						  bn_complex_t *b,
 						  bn_complex_t *c,
 						  bn_complex_t *d);
+						  
 BN_EXPORT extern int bn_poly_checkroots(bn_poly_t *eqn,
 					bn_complex_t *roots,
 					int nroots);
+					
 BN_EXPORT extern void bn_poly_deflate(bn_poly_t *oldP,
 				      bn_complex_t *root);
+				      
 BN_EXPORT extern int bn_poly_roots(bn_poly_t *eqn,
 				   bn_complex_t roots[],
 				   const char *name);
+				   
+/**
+ * b n _ p r _ p o l y
+ *
+ * Print out the polynomial.
+ */
 BN_EXPORT extern void bn_pr_poly(const char *title,
 				 const struct bn_poly *eqn);
+				 
+/**
+ * b n _ p r _ r o o t s
+ *
+ * Print out the roots of a given polynomial (complex numbers)
+ */
 BN_EXPORT extern void bn_pr_roots(const char *title,
 				  const struct bn_complex roots[],
 				  int n);
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* multipoly.c */
+
 /** @addtogroup multipoly */
-/** @{ */
+/** @{
+ *
+ *	Library for dealing with bivariate polynomials.
+ *
+ */
 
+
 /**
  * Polynomial data type
  */
@@ -1078,47 +2735,178 @@
 }  bn_multipoly_t;
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* qmath.c */
-/** @addtogroup mat */
-/** @{ */
+
 /*
  * Quaternion support
  */
 
+/** @addtogroup mat */
+/** @{
+ *
+ * @brief
+ *  Quaternion math routines.
+ *
+ *  Unit Quaternions:
+ *	Q = [ r, a ]	where r = cos(theta/2) = rotation amount
+ *			    |a| = sin(theta/2) = rotation axis
+ *
+ *      If a = 0 we have the reals; if one coord is zero we have
+ *	 complex numbers (2D rotations).
+ *
+ *  [r, a][s, b] = [rs - a.b, rb + sa + axb]
+ *
+ *       -1
+ *  [r, a]   = (r - a) / (r^2 + a.a)
+ *
+ *  Powers of quaternions yield incremental rotations,
+ *   e.g. Q^3 is rotated three times as far as Q.
+ *
+ *  Some operations on quaternions:
+ *            -1
+ *   [0, P'] = Q  [0, P]Q		Rotate a point P by quaternion Q
+ *                     -1  a
+ *   slerp(Q, R, a) = Q(Q  R)	Spherical linear interp: 0 < a < 1
+ *
+ *   bisect(P, Q) = (P + Q) / |P + Q|	Great circle bisector
+ *
+ *  Additions inspired by "Quaternion Calculus For Animation" by Ken Shoemake,
+ *  SIGGRAPH '89 course notes for "Math for SIGGRAPH", May 1989.
+ *
+ */
+
+
+
+/**
+ *			Q U A T _ M A T 2 Q U A T
+ *@brief
+ *  Convert Matrix to Quaternion.
+ */
 BN_EXPORT extern void quat_mat2quat(quat_t quat,
 				    const mat_t mat);
+				    
+/**
+ *			Q U A T _ Q U A T 2 M A T
+ *@brief
+ *  Convert Quaternion to Matrix.
+ *
+ * NB: This only works for UNIT quaternions.  We may get imaginary results
+ *   otherwise.  We should normalize first (still yields same rotation).
+ */
 BN_EXPORT extern void quat_quat2mat(mat_t mat,
 				    const quat_t quat);
+				    
+/**
+ *			Q U A T _ D I S T A N C E
+ *@brief
+ * Gives the euclidean distance between two quaternions.
+ */
 BN_EXPORT extern double quat_distance(const quat_t q1,
 				      const quat_t q2);
+
+/**
+ *			Q U A T _ D O U B L E
+ *@brief
+ * Gives the quaternion point representing twice the rotation
+ *   from q1 to q2.
+ *   Needed for patching Bezier curves together.
+ *   A rather poor name admittedly.
+ */				      
 BN_EXPORT extern void quat_double(quat_t qout,
 				  const quat_t q1,
 				  const quat_t q2);
+				  
+/**
+ *			Q U A T _ B I S E C T
+ *@brief
+ * Gives the bisector of quaternions q1 and q2.
+ * (Could be done with quat_slerp and factor 0.5)
+ * [I believe they must be unit quaternions this to work]
+ */
 BN_EXPORT extern void quat_bisect(quat_t qout,
 				  const quat_t q1,
 				  const quat_t q2);
+				  
+/**
+ *			Q U A T _ S L E R P
+ *@brief
+ * Do Spherical Linear Interpolation between two unit quaternions
+ *  by the given factor.
+ *
+ * As f goes from 0 to 1, qout goes from q1 to q2.
+ * Code based on code by Ken Shoemake
+ */
 BN_EXPORT extern void quat_slerp(quat_t qout,
 				 const quat_t q1,
 				 const quat_t q2,
 				 double f);
+				 
+/**
+ *			Q U A T _ S B E R P
+ *@brief
+ * Spherical Bezier Interpolate between four quaternions by amount f.
+ * These are intended to be used as start and stop quaternions along
+ *   with two control quaternions chosen to match spline segments with
+ *   first order continuity.
+ *
+ *  Uses the method of successive bisection.
+ */
 BN_EXPORT extern void quat_sberp(quat_t qout,
 				 const quat_t q1,
 				 const quat_t qa,
 				 const quat_t qb,
 				 const quat_t q2,
 				 double f);
+				 
+/**
+ *			Q U A T _ M A K E _ N E A R E S T
+ *@brief
+ *  Set the quaternion q1 to the quaternion which yields the
+ *   smallest rotation from q2 (of the two versions of q1 which
+ *   produce the same orientation).
+ *
+ * Note that smallest euclidian distance implies smallest great
+ *   circle distance as well (since surface is convex).
+ */
 BN_EXPORT extern void quat_make_nearest(quat_t q1,
 					const quat_t q2);
+					
+/**
+ *			Q U A T _ P R I N T
+ */
 BN_EXPORT extern void quat_print(const char *title,
 				 const quat_t quat);
+				 
+/**
+ *			Q U A T _ E X P
+ *@brief
+ *  Exponentiate a quaternion, assuming that the scalar part is 0.
+ *  Code by Ken Shoemake.
+ */
 BN_EXPORT extern void quat_exp(quat_t out,
 			       const quat_t in);
+			       
+/**
+ *			Q U A T _ L O G
+ *@brief
+ *  Take the natural logarithm of a unit quaternion.
+ *  Code by Ken Shoemake.
+ */
 BN_EXPORT extern void quat_log(quat_t out,
 			       const quat_t in);
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* rand.c */
+
 /** @addtogroup rnd */
 /** @{ */
 /**
@@ -1143,9 +2931,20 @@
  * numbers from bn_rand_table do not change, because the procedural
  * noise would cease to exist.
  */
+
+
 #define BN_RAND_TABSIZE 4096
 #define BN_RAND_TABMASK 0xfff
 #define BN_RANDSEED(_i, _seed)  _i = ((unsigned)_seed) % BN_RAND_TABSIZE
+
+/**
+ * This is our table of random numbers.  Rather than calling drand48()
+ * or random() or rand() we just pick numbers out of this table.  This
+ * table has 4096 unique entries with floating point values ranging
+ * from the open interval (i.e. exclusive) 0.0 to 1.0 range.
+ *
+ * There are convenience macros for access in the bn.h header.
+ */
 BN_EXPORT extern const float bn_rand_table[BN_RAND_TABSIZE];
 
 /** BN_RANDOM always gives numbers between the open interval 0.0 to 1.0 */
@@ -1188,13 +2987,29 @@
 #define bn_tab_sin(_a)	(((_a) > 0) ? \
 			 (bn_sin_table[(int)((0.5+ (_a)*bn_sin_scale))&(BN_SINTABSIZE-1)]) :\
 			 (-bn_sin_table[(int)((0.5- (_a)*bn_sin_scale))&(BN_SINTABSIZE-1)]))
+			 
+/**
+ * table of floating point sine values in the closed (i.e. inclusive)
+ * interval -1.0 to 1.0 range.
+ */
 BN_EXPORT extern const float bn_sin_table[BN_SINTABSIZE];
 
+/**
+ *			M A T H T A B _ C O N S T A N T
+ *@brief
+ *  For benchmarking purposes, make the random number table predictable.
+ *  Setting to all zeros keeps dithered values at their original values.
+ */
 BN_EXPORT extern void bn_mathtab_constant();
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* randmt.c */
+
 /** @addtogroup rnd */
 /** @{ */
 /**
@@ -1221,8 +3036,133 @@
 
 
 /*----------------------------------------------------------------------*/
+
+
 /* wavelet.c */
 
+/** @addtogroup wavelet */
+/** @{
+ *
+ * @brief
+ *  This is a standard wavelet library that takes a given data buffer of some data
+ *  type and then performs a wavelet transform on that data.
+ *
+ * The transform
+ *  operations available are to either decompose or reconstruct a signal into its
+ *  corresponding wavelet form based on the haar wavelet.
+ *
+ *  Wavelet decompose/reconstruct operations
+ *
+ *	- bn_wlt_haar_1d_double_decompose(tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_1d_float_decompose (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_1d_char_decompose  (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_1d_short_decompose (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_1d_int_decompose   (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_1d_long_decompose  (tbuffer, buffer, dimen, channels, limit)
+ *
+ *	- bn_wlt_haar_1d_double_reconstruct(tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_1d_float_reconstruct (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_1d_char_reconstruct  (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_1d_short_reconstruct (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_1d_int_reconstruct   (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_1d_long_reconstruct  (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *
+ *	- bn_wlt_haar_2d_double_decompose(tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_2d_float_decompose (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_2d_char_decompose  (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_2d_short_decompose (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_2d_int_decompose   (tbuffer, buffer, dimen, channels, limit)
+ *	- bn_wlt_haar_2d_long_decompose  (tbuffer, buffer, dimen, channels, limit)
+ *
+ *	- bn_wlt_haar_2d_double_reconstruct(tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_float_reconstruct (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_char_reconstruct  (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_short_reconstruct (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_int_reconstruct   (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_long_reconstruct  (tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *
+ *	- bn_wlt_haar_2d_double_decompose2(tbuffer, buffer, width, height, channels, limit)
+ *	- bn_wlt_haar_2d_float_decompose2 (tbuffer, buffer, width, height, channels, limit)
+ *	- bn_wlt_haar_2d_char_decompose2  (tbuffer, buffer, width, height, channels, limit)
+ *	- bn_wlt_haar_2d_short_decompose2 (tbuffer, buffer, width, height, channels, limit)
+ *	- bn_wlt_haar_2d_int_decompose2   (tbuffer, buffer, width, height, channels, limit)
+ *	- bn_wlt_haar_2d_long_decompose2  (tbuffer, buffer, width, height, channels, limit)
+ *
+ *	- bn_wlt_haar_2d_double_reconstruct2(tbuffer, buffer, width, height, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_float_reconstruct2 (tbuffer, buffer, width, height, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_char_reconstruct2  (tbuffer, buffer, width, height, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_short_reconstruct2 (tbuffer, buffer, width, height, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_int_reconstruct2   (tbuffer, buffer, width, height, channels, sub_sz, limit)
+ *	- bn_wlt_haar_2d_long_reconstruct2  (tbuffer, buffer, width, height, channels, sub_sz, limit)
+ *
+ *
+ *  For greatest accuracy, it is preferable to convert everything to "double"
+ *  and decompose/reconstruct with that.  However, there are useful
+ *  properties to performing the decomposition and/or reconstruction in
+ *  various data types (most notably char).
+ *
+ *  Rather than define all of these routines explicitly, we define
+ *  2 macros "decompose" and "reconstruct" which embody the structure of
+ *  the function (which is common to all of them).  We then instatiate
+ *  these macros once for each of the data types.  It's ugly, but it
+ *  assures that a change to the structure of one operation type
+ *  (decompose or reconstruct) occurs for all data types.
+ *
+ *
+ *
+ *
+ *  bn_wlt_haar_1d_*_decompose(tbuffer, buffer, dimen, channels, limit)
+ *  @par Parameters:
+ *	- tbuffer     a temporary data buffer 1/2 as large as "buffer". See (1) below.
+ *	- buffer      pointer to the data to be decomposed
+ *	- dimen    the number of samples in the data buffer
+ *	- channels the number of values per sample
+ *	- limit    the extent of the decomposition
+ *
+ *  Perform a Haar wavelet decomposition on the data in buffer "buffer".  The
+ *  decomposition is done "in place" on the data, hence the values in "buffer"
+ *  are not preserved, but rather replaced by their decomposition.
+ *  The number of original samples in the buffer (parameter "dimen") and the
+ *  decomposition limit ("limit") must both be a power of 2 (e.g. 512, 1024).
+ *  The buffer is decomposed into "average" and "detail" halves until the
+ *  size of the "average" portion reaches "limit".  Simultaneous
+ *  decomposition of multi-plane (e.g. pixel) data, can be performed by
+ *  indicating the number of planes in the "channels" parameter.
+ *
+ *  (1) The process requires a temporary buffer which is 1/2 the size of the
+ *  longest span to be decomposed.  If the "tbuffer" argument is non-null then
+ *  it is a pointer to a temporary buffer.  If the pointer is NULL, then a
+ *  local temporary buffer will be allocated (and freed).
+ *
+ *  @par Examples:
+ @code
+ double dbuffer[512], cbuffer[256];
+ ...
+ bn_wlt_haar_1d_double_decompose(cbuffer, dbuffer, 512, 1, 1);
+ @endcode
+ *
+ *    performs complete decomposition on the data in array "dbuffer".
+ *
+ @code
+ double buffer[3][512];	 /_* 512 samples, 3 values/sample (e.g. RGB?)*_/
+ double tbuffer[3][256];	 /_* the temporary buffer *_/
+ ...
+ bn_wlt_haar_1d_double_decompose(tbuffer, buffer, 512, 3, 1);
+ @endcode
+ *
+ *    This will completely decompose the data in buffer.  The first sample will
+ *    be the average of all the samples.  Alternatively:
+ *
+ * bn_wlt_haar_1d_double_decompose(tbuffer, buffer, 512, 3, 64);
+ *
+ *    decomposes buffer into a 64-sample "average image" and 3 "detail" sets.
+ *
+ *  bn_wlt_haar_1d_*_reconstruct(tbuffer, buffer, dimen, channels, sub_sz, limit)
+ *
+ */
+/** @} */
+
+
 #define CK_POW_2(dimen) { \
 	register unsigned long j; \
 	register int ok; \
@@ -1462,7 +3402,10 @@
 
 
 /*----------------------------------------------------------------------*/
+
+
 /* const.c */
+
 BN_EXPORT extern const double bn_pi;
 BN_EXPORT extern const double bn_twopi;
 BN_EXPORT extern const double bn_halfpi;
@@ -1473,8 +3416,32 @@
 BN_EXPORT extern const double bn_radtodeg;
 
 /*----------------------------------------------------------------------*/
+
+
 /* tabdata.c */
 
+/** @addtogroup anim */
+/** @{ */
+
+/** @brief
+ *  Routines for processing tables (curves) of data with one independent
+ *  parameter which is common to many sets of dependent data values.
+ *
+ *  Operates on bn_table (independent var) and
+ *  bn_tabdata (dependent variable) structures.
+ *
+ *  One application is for storing spectral curves, see spectrum.c
+ *
+ *  @par Inspired by -
+ *	Roy Hall and his book "Illumination and Color in Computer
+ *@n	Generated Imagery", Springer Verlag, New York, 1989.
+ *@n	ISBN 0-387-96774-5
+ *
+ *  With thanks to Russ Moulton Jr, EOSoft Inc. for his "rad.c" module.
+ */
+/** @} */
+
+
 /**
  * T A B D A T A
  *
@@ -1513,6 +3480,7 @@
  * frequencies.
  *
  */
+
 struct bn_table {
     uint32_t magic;
     size_t nx;
@@ -1565,51 +3533,140 @@
  * Routines
  */
 
+/*
+ *			B N _ T A B L E _ F R E E
+ */
 BN_EXPORT extern void bn_table_free(struct bn_table *tabp);
+
+/*
+ *			B N _ T A B D A T A _ F R E E
+ */
 BN_EXPORT extern void bn_tabdata_free(struct bn_tabdata *data);
+
+/*
+ *			B N _ C K _ T A B L E
+ */
 BN_EXPORT extern void bn_ck_table(const struct bn_table *tabp);
+
+/*
+ *			B N _ T A B L E _ M A K E _ U N I F O R M
+ *@brief
+ *  Set up an independent "table margin" from 'first' to 'last',
+ *  inclusive, using 'num' uniformly spaced samples.  Num >= 1.
+ */
 BN_EXPORT extern struct bn_table *bn_table_make_uniform(size_t num,
 							double first,
 							double last);
+							
+/*
+ *			B N _ T A B D A T A _ A D D
+ *@brief
+ *  Sum the values from two data tables.
+ */
 BN_EXPORT extern void bn_tabdata_add(struct bn_tabdata *out,
 				     const struct bn_tabdata *in1,
 				     const struct bn_tabdata *in2);
+				     
+/*
+ *			B N _ T A B D A T A _ M U L
+ *@brief
+ *  Element-by-element multiply the values from two data tables.
+ */
 BN_EXPORT extern void bn_tabdata_mul(struct bn_tabdata *out,
 				     const struct bn_tabdata *in1,
 				     const struct bn_tabdata *in2);
+				     
+/*
+ *			B N _ T A B D A T A _ M U L 3
+ *@brief
+ *  Element-by-element multiply the values from three data tables.
+ */
 BN_EXPORT extern void bn_tabdata_mul3(struct bn_tabdata *out,
 				      const struct bn_tabdata *in1,
 				      const struct bn_tabdata *in2,
 				      const struct bn_tabdata *in3);
+				      
+/*
+ *			B N _ T A B D A T A _ I N C R _ M U L 3 _ S C A L E
+ *@brief
+ *  Element-by-element multiply the values from three data tables and a scalor.
+ *
+ *	out += in1 * in2 * in3 * scale
+ */
 BN_EXPORT extern void bn_tabdata_incr_mul3_scale(struct bn_tabdata *out,
 						 const struct bn_tabdata *in1,
 						 const struct bn_tabdata *in2,
 						 const struct bn_tabdata *in3,
 						 double scale);
+						 
+/*
+ *			B N _ T A B D A T A _ I N C R _ M U L 2 _ S C A L E
+ *@brief
+ *  Element-by-element multiply the values from two data tables and a scalor.
+ *
+ *	out += in1 * in2 * scale
+ */
 BN_EXPORT extern void bn_tabdata_incr_mul2_scale(struct bn_tabdata *out,
 						 const struct bn_tabdata *in1,
 						 const struct bn_tabdata *in2,
 						 double scale);
+						 
+/*
+ *			B N _ T A B D A T A _ S C A L E
+ *@brief
+ *  Multiply every element in a data table by a scalar value 'scale'.
+ */
 BN_EXPORT extern void bn_tabdata_scale(struct bn_tabdata *out,
 				       const struct bn_tabdata *in1,
 				       double scale);
+				       
+/*
+ *			B N _ T A B L E _ S C A L E
+ *@brief
+ *  Scale the indepentent axis of a table by 'scale'.
+ */
 BN_EXPORT extern void bn_table_scale(struct bn_table *tabp,
 				     double scale);
+				     
+/*
+ *			B N _ T A B D A T A _ J O I N 1
+ *@brief
+ *  Multiply every element in data table in2 by a scalar value 'scale',
+ *  add it to the element in in1, and store in 'out'.
+ *  'out' may overlap in1 or in2.
+ */
 BN_EXPORT extern void bn_tabdata_join1(struct bn_tabdata *out,
 				       const struct bn_tabdata *in1,
 				       double scale,
 				       const struct bn_tabdata *in2);
+				       
+/*
+ *			B N _ T A B D A T A _ J O I N 2
+ *@brief
+ *  Multiply every element in data table in2 by a scalar value 'scale2',
+ *  plus in3 * scale3, and
+ *  add it to the element in in1, and store in 'out'.
+ *  'out' may overlap in1 or in2.
+ */
 BN_EXPORT extern void bn_tabdata_join2(struct bn_tabdata *out,
 				       const struct bn_tabdata *in1,
 				       double scale2,
 				       const struct bn_tabdata *in2,
 				       double scale3,
 				       const struct bn_tabdata *in3);
+				       
+/*
+ *			B N _ T A B D A T A _ B L E N D 2
+ */
 BN_EXPORT extern void bn_tabdata_blend2(struct bn_tabdata *out,
 					double scale1,
 					const struct bn_tabdata *in1,
 					double scale2,
 					const struct bn_tabdata *in2);
+					
+/*
+ *			B N _ T A B D A T A _ B L E N D 3
+ */
 BN_EXPORT extern void bn_tabdata_blend3(struct bn_tabdata *out,
 					double scale1,
 					const struct bn_tabdata *in1,
@@ -1617,61 +3674,275 @@
 					const struct bn_tabdata *in2,
 					double scale3,
 					const struct bn_tabdata *in3);
+					
+/*
+ *			B N _ T A B D A T A _ A R E A 1
+ *@brief
+ *  Following interpretation #1, where y[j] stores the total (integral
+ *  or area) value within the interval, return the area under the whole curve.
+ *  This is simply totaling up the areas from each of the intervals.
+ */
 BN_EXPORT extern double bn_tabdata_area1(const struct bn_tabdata *in);
+
+/*
+ *			B N _ T A B D A T A _ A R E A 2
+ *@brief
+ *  Following interpretation #2, where y[j] stores the average
+ *  value for the interval, return the area under
+ *  the whole curve.  Since the iterval spacing need not be uniform,
+ *  sum the areas of the rectangles.
+ */
 BN_EXPORT extern double bn_tabdata_area2(const struct bn_tabdata *in);
+
+/*
+ *			B N _ T A B D A T A _ M U L _ A R E A 1
+ *@brief
+ *  Following interpretation #1, where y[j] stores the total (integral
+ *  or area) value within the interval, return the area under the whole curve.
+ *  This is simply totaling up the areas from each of the intervals.
+ *  The curve value is found by multiplying corresponding entries from
+ *  in1 and in2.
+ */
 BN_EXPORT extern double bn_tabdata_mul_area1(const struct bn_tabdata *in1,
 					     const struct bn_tabdata *in2);
+					     
+/*
+ *			B N _ T A B D A T A _ M U L _ A R E A 2
+ *@brief
+ *  Following interpretation #2,
+ *  return the area under the whole curve.
+ *  The curve value is found by multiplying corresponding entries from
+ *  in1 and in2.
+ */
 BN_EXPORT extern double bn_tabdata_mul_area2(const struct bn_tabdata *in1,
 					     const struct bn_tabdata *in2);
+					     
+/*
+ *			B N _ T A B L E _ L I N _ I N T E R P
+ *@brief
+ *  Return the value of the curve at independent parameter value 'wl'.
+ *  Linearly interpolate between values in the input table.
+ *  Zero is returned for values outside the sampled range.
+ */
 BN_EXPORT extern fastf_t bn_table_lin_interp(const struct bn_tabdata *samp,
 					     double wl);
+					     
+/*
+ *			B N _ T A B D A T A _ R E S A M P L E _ M A X
+ *@brief
+ *  Given a set of sampled data 'olddata', resample it for different
+ *  spacing, by linearly interpolating the values when an output span
+ *  is entirely contained within an input span, and by taking the
+ *  maximum when an output span covers more than one input span.
+ *
+ *  This assumes interpretation (2) of the data, i.e. that the values
+ *  are the average value across the interval.
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_resample_max(const struct bn_table *newtable,
 							    const struct bn_tabdata *olddata);
+							    
+/*
+ *			B N _ T A B D A T A _ R E S A M P L E _ A V G
+ *@brief
+ *  Given a set of sampled data 'olddata', resample it for different
+ *  spacing, by linearly interpolating the values when an output span
+ *  is entirely contained within an input span, and by taking the
+ *  average when an output span covers more than one input span.
+ *
+ *  This assumes interpretation (2) of the data, i.e. that the values
+ *  are the average value across the interval.
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_resample_avg(const struct bn_table *newtable,
 							    const struct bn_tabdata *olddata);
+							    
+/*
+ *			B N _ T A B L E _ W R I T E
+ *@brief
+ *  Write out the table structure in an ASCII file,
+ *  giving the number of values (minus 1), and the
+ *  actual values.
+ */
 BN_EXPORT extern int bn_table_write(const char *filename,
 				    const struct bn_table *tabp);
+				    
+/*
+ *			B N _ T A B L E _ R E A D
+ *@brief
+ *  Allocate and read in the independent variable values from an ASCII file,
+ *  giving the number of samples (minus 1), and the
+ *  actual values.
+ */
 BN_EXPORT extern struct bn_table *bn_table_read(const char *filename);
+
+/*
+ *			B N _ P R _ T A B L E
+ */
 BN_EXPORT extern void bn_pr_table(const char *title,
 				  const struct bn_table *tabp);
+				  
+/*
+ *			B N _ P R _ T A B D A T A
+ */
 BN_EXPORT extern void bn_pr_tabdata(const char *title,
 				    const struct bn_tabdata *data);
+				    
+/*
+ *			B N _ P R I N T _ T A B L E _ A N D _ T A B D A T A
+ *@brief
+ *  Write out a given data table into an ASCII file,
+ *  suitable for input to GNUPLOT.
+ *
+ *	(set term postscript)
+ *	(set output "|print-postscript")
+ *	(plot "filename" with lines)
+ */
 BN_EXPORT extern int bn_print_table_and_tabdata(const char *filename,
 						const struct bn_tabdata *data);
+						
+/*
+ *			B N _ R E A D _ T A B L E _ A N D _ T A B D A T A
+ *@brief
+ *  Read in a file which contains two columns of numbers, the first
+ *  column being the wavelength, the second column being the sample value
+ *  at that wavelength.
+ *
+ *  A new bn_table structure and one bn_tabdata structure
+ *  are created, a pointer to the bn_tabdata structure is returned.
+ *  The final wavelength is guessed at.
+ */
 BN_EXPORT extern struct bn_tabdata *bn_read_table_and_tabdata(const char *filename);
+
+/*
+ *			B N _ T A B D A T A _ B I N A R Y _ R E A D
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_binary_read(const char *filename,
 							   size_t num,
 							   const struct bn_table *tabp);
+							   
+/*
+ *			B N _ T A B D A T A _ M A L L O C _ A R R A Y
+ *@brief
+ *  Allocate storage for, and initialize, an array of 'num' data table
+ *  structures.
+ *  This subroutine is provided because the bn_tabdata structures
+ *  are variable length.
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_malloc_array(const struct bn_table *tabp,
 							    size_t num);
+							    
+/*
+ *			B N _ T A B D A T A _ C O P Y
+ */
 BN_EXPORT extern void bn_tabdata_copy(struct bn_tabdata *out,
 				      const struct bn_tabdata *in);
+				      
+/*
+ *			B N _ T A B D A T A _ D U P
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_dup(const struct bn_tabdata *in);
+
+/*
+ *			B N _ T A B D A T A _ G E T _ C O N S T V A L
+ *@brief
+ *  For a given table, allocate and return a tabdata structure
+ *  with all elements initialized to 'val'.
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_get_constval(double val,
 							    const struct bn_table *tabp);
+							    
+/*
+ *			B N _ T A B D A T A _ C O N S T V A L
+ *@brief
+ *  Set all the tabdata elements to 'val'
+ */
 BN_EXPORT extern void bn_tabdata_constval(struct bn_tabdata *data,
 					  double val);
+					  
+/*
+ *			B N _ T A B D A T A _ T O _ T C L
+ *@brief
+ *  Convert an bn_tabdata/bn_table pair into a Tcl compatible string
+ *  appended to a VLS.  It will have form:
+ *	x {...} y {...} nx # ymin # ymax #
+ */
 BN_EXPORT extern void bn_tabdata_to_tcl(struct bu_vls *vp,
 					const struct bn_tabdata *data);
+					
+/*
+ *			B N _ T A B D A T A _ F R O M _ A R R A Y
+ *@brief
+ *  Given an array of (x, y) pairs, build the relevant bn_table and
+ *  bn_tabdata structures.
+ *
+ *  The table is terminated by an x value <= 0.
+ *  Consistent with the interpretation of the spans,
+ *  invent a final span ending x value.
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_from_array(const double *array);
+
+/*
+ *			B N _ T A B D A T A _ F R E Q _ S H I F T
+ *@brief
+ *  Shift the data by a constant offset in the independent variable
+ *  (often frequency), interpolating new sample values.
+ */
 BN_EXPORT extern void bn_tabdata_freq_shift(struct bn_tabdata *out,
 					    const struct bn_tabdata *in,
 					    double offset);
+					    
+/*
+ *			B N _ T A B L E _ I N T E R V A L _ N U M _ S A M P L E S
+ *@brief
+ *  Returns number of sample points between 'low' and 'hi', inclusive.
+ */
 BN_EXPORT extern int bn_table_interval_num_samples(const struct bn_table *tabp,
 						   double low,
 						   double hi);
+						   
+/*
+ *			B N _ T A B L E _ D E L E T E _ S A M P L E _ P T S
+ *@brief
+ *  Remove all sampling points between subscripts i and j, inclusive.
+ *  Don't bother freeing the tiny bit of storage at the end of the array.
+ *  Returns number of points removed.
+ */
 BN_EXPORT extern int bn_table_delete_sample_pts(struct bn_table *tabp,
 						unsigned int i,
 						unsigned int j);
+						
+/*
+ *			B N _ T A B L E _ M E R G E 2
+ *@brief
+ *  A new table is returned which has sample points at places from
+ *  each of the input tables.
+ */
 BN_EXPORT extern struct bn_table *bn_table_merge2(const struct bn_table *a,
 						  const struct bn_table *b);
+						  
+/*
+ *		B N _ T A B D A T A _ M K _ L I N E A R _ F I L T E R
+ *@brief
+ *  Create a filter to accept power in a given band.
+ *  The first and last filter values will be in the range 0..1,
+ *  while all the internal filter values will be 1.0,
+ *  and all samples outside the given band will be 0.0.
+ *
+ *
+ *  @return	NULL	if given band does not overlap input spectrum
+ *  @return	tabdata*
+ */
 BN_EXPORT extern struct bn_tabdata *bn_tabdata_mk_linear_filter(const struct bn_table *spectrum,
 								double lower_wavelen,
 								double upper_wavelen);
 
+
 /*----------------------------------------------------------------------*/
+
+
 /* vlist.c */
+
 #define BN_VLIST_CHUNK 35		/**< @brief 32-bit mach => just less than 1k */
+
 /**
  * B N _ V L I S T
  *
